/*
   AppInitialise.h - blackhome resourceFileManager app launcher

   Will 18, 1999.

   This file is part of blackhome, the window manager manager for the 
   blackbox window manager.

   blackhome is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   blackhome is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with blackhome; see the file COPYING.  If not, write to the Free
   Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _APPINIT_H_
#define _APPINIT_H_

#include <X11/Intrinsic.h>

#include "resourceFileEditorResources.h"
#include "ResourceFileEditor.h"

/*
 *  Resources defined in resourceFileEditorResources.h
 */

static XtResource resources[] = {
	{ "toplabelWidth", "topLabelWidth", XtRInt, sizeof ( int ),
		XtOffsetOf ( rfeResources, topLabelWidth ), XtRImmediate, ( void * ) "115" },
	{ "maxMenuItems", "maxMenuItems", XtRInt, sizeof ( int ),
		XtOffsetOf ( rfeResources, maxMenuItems ), XtRImmediate, ( void * ) "30" },
	{ "rgbTxtDir", "rgbTxtDir", XtRString, sizeof ( String ),
		XtOffsetOf ( rfeResources, rgbTxtDir ), XtRImmediate, ( void * ) "/var/X11R6/lib/rgb.txt" },
	{ "XdefaultsDir", "XdefaultsDir", XtRString, sizeof ( String ),
		XtOffsetOf ( rfeResources, XdefaultsDir ), XtRImmediate, ( void * ) ".blackhome/Xdefaults" },
	{ "appResDir", "appResDir", XtRString, sizeof ( String ),
		XtOffsetOf ( rfeResources, appResDir ), XtRImmediate,( void * ) ".blackhome/app-defaults" },
	{ "stylesDir", "stylesDir", XtRString, sizeof ( String ),
		XtOffsetOf ( rfeResources, stylesDir ), XtRImmediate, ( void * ) ".blackhome/styles" },
	{ "menusDir", "menusDir", XtRString, sizeof ( String ),
		XtOffsetOf ( rfeResources, menusDir ), XtRImmediate, ( void * ) ".blackhome/menus" },
	{ "resourceDir", "resourceDir", XtRString, sizeof ( String ),
		XtOffsetOf ( rfeResources, resourceDir ), XtRImmediate, ( void * ) ".blackhome/config" },
	{ "currentThemeSpecifier", "currentThemeSpecifier", XtRString, sizeof ( String ),
		XtOffsetOf ( rfeResources, currentThemeSpecifier ), XtRImmediate, ( void * ) "User styles" }
};

/*
 *  Default resources in absence of external app defs file ResourceFileEditor
 */

static String fallback_resources[] = {
	"ResourceFileEditor*topLabelWidth: 115",
	"ResourceFileEditor*font: -b&h-lucidatypewriter-*-*-*-*-*-*-*-*-*-*-*-*",
	"ResourceFileEditor*maxMenuItems: 30",

	"ResourceFileEditor*foreground: white",
	"ResourceFileEditor*background: grey35",

	"ResourceFileEditor*label*borderColor: grey40",
	"ResourceFileEditor*label*borderWidth: 1",
	"ResourceFileEditor*label*background: grey50",

	"ResourceFileEditor*Quit*foreground: white",
	"ResourceFileEditor*Quit*background: grey50",
	"ResourceFileEditor*Quit*borderColor: grey45",
	"ResourceFileEditor*Quit*borderWidth: 1",

	"ResourceFileEditor*Find*foreground: white",
	"ResourceFileEditor*Find*background: grey50",
	"ResourceFileEditor*Find*borderColor: grey45",
	"ResourceFileEditor*Find*borderWidth: 1",

	"ResourceFileEditor*Opts*foreground: white",
	"ResourceFileEditor*Opts*background: grey50",
	"ResourceFileEditor*Opts*borderColor: grey45",
	"ResourceFileEditor*Opts*borderWidth: 1",

	"ResourceFileEditor*Seln*foreground: white",
	"ResourceFileEditor*Seln*background: grey50",
	"ResourceFileEditor*Seln*borderColor: grey45",
	"ResourceFileEditor*Seln*borderWidth: 1",

	"ResourceFileEditor*View*foreground: white",
	"ResourceFileEditor*View*background: grey50",
	"ResourceFileEditor*View*borderColor: grey45",
	"ResourceFileEditor*View*borderWidth: 1",

	"ResourceFileEditor*Exec*foreground: white",
	"ResourceFileEditor*Exec*background: grey50",
	"ResourceFileEditor*Exec*borderColor: grey45",
	"ResourceFileEditor*Exec*borderWidth: 1",

	"ResourceFileEditor*Text*background: grey50",
	"ResourceFileEditor*Text*foreground: white",
	"ResourceFileEditor*Text*borderWidth: 2",
	"ResourceFileEditor*Text*borderColor: grey65",
	
	"ResourceFileEditor*Find_resource*asciiText*background: black",

	"ResourceFileEditor*ResourceFileEditor_error*asciiText*background: red",

	"ResourceFileEditor*ColourSpecConvert*asciiText*background: black",

	"ResourceFileEditor*ColourSpecConvert_report*asciiText*background: black",

	"ResourceFileEditor*ColourSpecConvert_error*asciiText*background: red",
    NULL
};

AppResources app_resources;

#endif
