/*
   appInitialise.cc - blackhome resourceFileManager app launcher

   Will 18, 1999.

   This file is part of blackhome.

   blackhome is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   blackhome is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with blackhome; see the file COPYING.  If not, write to the Free
   Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/
 
#include "AppInitialise.h"

#include <X11/Shell.h>
#include <X11/StringDefs.h>		/* Standard Name-String definitions */


int main ( int argc, char *argv[] )
{
	XtAppContext app;
	Widget shell;
	
	if ( argc < 2 )
	{
		printf ( "usage: resourceFileEditor <homeDir>\n" );
		return 1;
	}
	
	shell = XtOpenApplication ( &app, "ResourceFileEditor", NULL, 0, &argc, argv,
								fallback_resources, applicationShellWidgetClass, NULL, 0 );
								
	XtGetApplicationResources ( shell, ( XtPointer ) &app_resources, resources,
								XtNumber ( resources ), NULL, 0 );

	ResourceFileEditor *resourceFileEditor = new ResourceFileEditor ( argv[1],
								( XtPointer ) &app_resources, "resourceFileEditor",
								shell, app );

	XtRealizeWidget ( shell );
	XtAppMainLoop ( app );
}
