/* 
   Menu.h: simple Menu widget component

   Copyright (C) Will 18, 1999.

   This file is part of blackhome.

   blackhome is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   blackhome is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with blackhome; see the file COPYING.  If not, write to the Free
   Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef Menu_H
#define Menu_H

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/Simple.h>
#include <X11/Xaw/Sme.h>
#include <X11/Xaw/SmeBSB.h>
#include <X11/Xaw/SmeLine.h>


enum MENU_STATE { MENU_NOT_USEFUL, MENU_OK_PRESSED, MENU_CANCEL_PRESSED };

class Menu;
struct menuWidgetSet { int n; Menu *menu; };


class Menu
{
	public:
		Menu ( const char *, Widget, const char *, 
					 const char *, ... ); 

		// name, parent widget, menu popup label, 
		// menu activate button label, menu entry list title,
		// menu entries
			 
		Menu ( const char *, Widget, const char *,
					const char *, int, int, char * );
		 
		// instead of fixed string menu entries, will also accept
		// no. of items in menu, size of char array storing entries,
		// pointer to base address of char array

		~Menu();
		void setStateToNOTUseful ( void );
      int getSelectedItem ( void ) { return _selectedItemNumber; }
		MENU_STATE getState ( void );

      Widget _popup;

	private:
  		Widget _menuButton, _menu, _entry;
      MENU_STATE _state;

		void setSelectedItem ( int n ) { _selectedItemNumber = n; }

		int _selectedItemNumber;
		int numberOfPointersToMemBlocks;
		menuWidgetSet ** arrayOfPointersToMemBlocks;

     	// member functions called by callback functions
      void menuEntrySelect ( Menu *, int );
 
     	// callback functions
		static void menuEntrySelectCallback( Widget, XtPointer, XtPointer );
};

#endif
