/* 
   text.h: simple ascii text widget component

   Copyright (C) Will 18, 1999.

   This file is part of blackhome.

   blackhome is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   blackhome is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with blackhome; see the file COPYING.  If not, write to the Free
   Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef TEXT_H
#define TEXT_H

#include "../Global.h"

#include <X11/Intrinsic.h>
#include <X11/Xaw3d/Form.h>
#include <X11/Xaw3d/Command.h>
#include <X11/Xaw3d/AsciiText.h>
#include <X11/Xaw3d/Label.h>


enum TEXT_STATE { TEXT_NOT_USEFUL, TEXT_OK_PRESSED, TEXT_CANCEL_PRESSED };


class Text
{
	public:
		Text ( const char *, Widget ); // name, parent widget, label
		~Text();
		void setLabelText ( char * );
		void setStateToNOTUseful ( void );
		char *getText( void);
		void setText ( char *);
		TEXT_STATE getState ( void );
		Widget _popup;

	private:
  		Widget _label;
		Widget _form;
		Widget _button;
		Widget _asciiText;
		char *_text;
		TEXT_STATE _state;

     	// member functions called by callback functions
		void ok ( Widget, XtPointer );
		void cancel ( Widget, XtPointer );

     	// callback functions
		static void okCallback ( Widget, XtPointer, XtPointer );
		static void cancelCallback ( Widget, XtPointer, XtPointer );
};

#endif
