/* 
   textTest.cc test program for the text component class

   Copyright (C) Will 18, 1999.

   This file is part of blackhome.

   blackhome is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   blackhome is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with blackhome; see the file COPYING.  If not, write to the Free
   Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "Text.h"

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <iostream>

void quitCallback ( Widget, XtPointer, XtPointer );
void inputCallback ( Widget, XtPointer, XtPointer );

XtAppContext app;


int main ( int argc, char *argv[] )
{
	Arg args[3];
   Widget shell, form, button, popup;
 
   shell = XtOpenApplication ( &app, "Input", NULL, 0, &argc, argv, NULL,
										shellWidgetClass,	NULL, 0 );

   form = XtCreateManagedWidget ( "form" , formWidgetClass, shell, NULL, 0);

   popup = XtCreatePopupShell ( "Popup", shellWidgetClass, form, NULL, 0 );

   Text *myText = new Text ( "myText", popup );

   button = XtCreateManagedWidget ( "Quit ", commandWidgetClass, form, 
                                      NULL, 0 );

   XtAddCallback ( button, XtNcallback, quitCallback, NULL );

	int n = 0;
	XtSetArg ( args[n], XtNfromVert, button ); n++;

   button = XtCreateManagedWidget ( "Text", commandWidgetClass, form,
                                      args, n );                                 		

   XtAddCallback ( button, XtNcallback, inputCallback, ( XtPointer ) myText );
                                         
   XtRealizeWidget ( shell );
   XtAppMainLoop ( app );
}    

void quitCallback ( Widget, XtPointer, XtPointer )
{     
   exit ( 0 );
}

void inputCallback ( Widget, XtPointer clientData, XtPointer )
{
   char *inputText; // pointer to text
 	
   Text *enteredText = ( Text * ) clientData; // ptr to Text widget with text 
	enteredText->setLabelText ( "input" ); // give it a label   
	enteredText->setText("Type something...");	// just test display fn

	XtPopup ( ( Widget ) enteredText->_popup, XtGrabNone ); // popup widget

   XEvent enteredTextEvent; // wait on Text widget event

   while ( enteredText->getState() == TEXT_NOT_USEFUL )
   {
   	XtAppNextEvent ( app, &enteredTextEvent );
   	XtDispatchEvent ( &enteredTextEvent );
   }
   
   XtPopdown ( ( Widget ) enteredText->_popup );

   if ( enteredText->getState() == TEXT_CANCEL_PRESSED )
   {
   	printf ( "cancelled action\n" );
      enteredText->setStateToNOTUseful();
   }
   
   if ( enteredText->getState() == TEXT_OK_PRESSED )   
   {
   	inputText = enteredText->getText();

	printf ( "%s\n", inputText );
	// now we can do something with it!
      enteredText->setStateToNOTUseful();
	}
}

