#!/bin/sh
# preprocess.sh - actions taken before themes are started

# build list of gtk styles available for gtk styles submenu
# remove old gtk theme list on blackbox theme startup
gtkstylefile=~/.blackhome/Xdefaults/gtk/gtk-stylesmenu
rm -f $gtkstylefile
# remove gtk theme control scripts in case of gtk theme removal
rm -f ~/.blackhome/Xdefaults/gtk/*.sh

stylefile=""
stylesmenu=""
styles=""
gtkstyles=""

# scan dirs, build gtk themes list - try looking in standard places for themes
for x in /opt/gnome/share /usr/share /usr/local/share
do
  if [ -d "$x/themes" ]; then
    styles=$(ls $x/themes)
  fi

  # check for gtk themes
  for y in $styles
  do
    # find out whether style has a gtk subdir
    # in which case presume it has a gtkrc and is a style
    stylefile=$x"/themes/"$y

    if [ -d "$stylefile/gtk" ]; then
      # build gtk themes list
      gtkstyles=$gtkstyles" "$x"/themes/"$y
    fi
  done
done

# build gtk-stylesmenu but instead of activating style change
# just call shell script to do the linking
sect1='[exec] ('
sect2=') {~/.blackhome/Xdefaults/gtk/'
sect3='.sh}'

for x in $gtkstyles
do
  filename=$(basename $x)
  stylesmenu=$sect1$filename$sect2$filename$sect3
  echo $stylesmenu >> $gtkstylefile
  # make <gtkThemeName>.sh scripts in .blackhome/Xdefaults/gtk dir
  scriptname=~/.blackhome/Xdefaults/gtk/$filename'.sh'

  echo '#!/bin/sh' > $scriptname
  # if we find 'pre', remove the 'post' link and vice-versa
  echo 'if [ -r ~/.blackhome/control/gtk-prestyle ]; then' >> $scriptname
  echo '  ln -sf' $x'/gtk/gtkrc' $HOME'/.blackhome/Xdefaults/gtk/gtk-prestyle' >> $scriptname
  echo '  rm -f ~/.blackhome/Xdefaults/gtk/gtk-poststyle' >> $scriptname
  echo 'elif [ -r ~/.blackhome/control/gtk-poststyle ]; then' >> $scriptname
  echo '  ln -sf' $x'/gtk/gtkrc' $HOME'/.blackhome/Xdefaults/gtk/gtk-poststyle' >> $scriptname
  echo '  rm -f ~/.blackhome/Xdefaults/gtk/gtk-prestyle' >> $scriptname
  echo 'else' >> $scriptname
  echo '  rm -f ~/.blackhome/Xdefaults/gtk/gtk-prestyle' >> $scriptname
  echo '  rm -f ~/.blackhome/Xdefaults/gtk/gtk-poststyle' >> $scriptname
  echo 'fi' >> $scriptname
  echo "bh_pixmap_path='../../app-defaults/pixmaps/'"'$(less ~/.blackhome/control/current_theme)''":'$x'/gtk"' >> $scriptname
  echo "echo 'pixmap_path' ""'\"'\$bh_pixmap_path'\"' > ~/.blackhome/Xdefaults/gtk/pixmap-path" >> $scriptname
  chmod u+x $scriptname
done
